<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;

class TiposTareasController extends Controller
{
    public function mostrarTodos(){
        $TiposTareas = DB::table('tareas_tipos')
        ->where('idEscuela', 'COLEGIOABC')
        ->get();
        return response()->json($TiposTareas); 
    } 
   
    public function crear(Request $request){
       $message = '';
       $status = 0;
        try{
            $TiposTareas = DB::table('tareas_tipos')->insert([
                'idEscuela' => 'COLEGIOABC',
                'idTareasTipos' => $request->clave,
                'nombreTareasTipos' => $request->nombre,
                'envioPlatTareasTipos' => $request->envio,
                'estado' => 'Activo',
                'idUsuarioCc' => ''
            ]);
            $message = 'Tipo de tarea creado correctamente'; $status = 200;
        } catch(\Exception $e){
            $message = 'Error al crear el tipo de tarea'; $status = 500;
        }
        return response()->json(['mensaje' => $message], $status);
    }

    public function editar(Request $request, $idTareasTipos){
        $id = base64_decode($idTareasTipos);
        $message = '';
       $status = 0;
        try{
            $TiposTareas = DB::table('tareas_tipos')
            ->where('idTareasTipos', $id)
            ->Update([
                'nombreTareasTipos' => $request->nombre,
                'envioPlatTareasTipos' => $request->envio,
            ]);
            $message = 'Tipo de tarea Actualizado correctamente'; $status = 200;
        } catch(\Exception $e){
            $message = 'Error al Actualizar el tipo de tarea'; $status = 500;
        }
        return response()->json(['mensaje' => $message], $status);
    }

    public function Actualizar($id){
        $id = base64_decode($id);
        $message = '';
        $status = 0;
        try{
            $TiposTareas = DB::table('tareas_tipos')
            ->where('idTareasTipos', $id)
            ->update([
                'estado' => 'Eliminado',
            ]);
            $message = 'Tipo de tarea eliminado correctamente'; 
            $status = 200;
        } catch(\Exception $e){
            $message = 'Error al eliminar el tipo de tarea'; 
            $status = 500;
        }
        return response()->json(['mensaje' => $message], $status);
    }

    public function habilitar($id){
        $id = base64_decode($id);
        $message = '';
        $status = 0;
        try{
            $TiposTareas = DB::table('tareas_tipos')
            ->where('idEscuela', 'COLEGIOABC')
            ->where('idTareasTipos', $id)
            ->update([
                'estado' => 'Activo',
            ]);
            $message = 'Tipo de tarea habilitado correctamente'; 
            $status = 200;
        } catch(\Exception $e){
            $message = 'Error al habilitar el tipo de tarea'; 
            $status = 500;
        }
        return response()->json(['mensaje' => $message], $status);
    }

}
